﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private XUI As XUI
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	Dim bImage As B4XBitmap
		bImage = XUI.LoadBitmap(File.DirAssets, "Erel and Klaus.jpg")
	Dim c() As Byte = XUIImageToJPEGByteArray(bImage, -50, 0, 50)
	'https://www.b4x.com/android/forum/threads/b4x-bytes-to-file.70111/#content
	XUI.SetDataFolder("ImageBytes")
	BytesToFile(XUI.DefaultFolder, "b.jpg", c)	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Sub BytesToFile (Dir As String, FileName As String, Data() As Byte)
	Dim Out As OutputStream = File.OpenOutput(Dir, FileName, False)
		Out.WriteBytes(Data, 0, Data.Length)
		Out.Close
End Sub

Sub FileToBytes (Dir As String, FileName As String) As Byte()
	Return Bit.InputStreamToBytes(File.OpenInput(Dir, FileName))
End Sub

#Region Image to Byte Array 
Sub XUIImageToJPEGByteArray(aImage As Object, width As Int, height As Int, quality As Int) As Byte()
	'Sanity check quality
	If (quality < -1 And quality > 100) Then
		Log("Parameter quality not in range (-1..100)")
		Return Array As Byte ()
	End If
	If quality = -1 Then quality = 75

	'Sanity check incoming image
	Try
		Dim image As B4XBitmap = aImage
	Catch
		Log(LastException)
		Return Array As Byte ()
	End Try
  
	'Sanity check incoming image dimensions
	Dim oldWidth As Int = image.Width
	Dim oldHeight As Int = image.Height
	If (oldWidth = 0 And oldHeight = 0 ) Then
		Log("Source image with incorrect dimensions")
		Return Array As Byte ()
	End If

	'See if were resizing the image
	Dim  resize As Boolean = True
	If ((width = 0 And height = 0) Or (width = -100 Or height = -100)) Then resize = False
  
	'Resize if necessary
	If (resize) Then
		Dim newWidth As Int = width
		Dim newHeight As Int = height
		'Calculate new dimensions
		If (newWidth < 0) Then newWidth = -1 * oldWidth * newWidth / 100
		If (newHeight < 0) Then newHeight = -1 * oldHeight * newHeight / 100
		If (newWidth = 0) Then newWidth = oldWidth * newHeight / oldHeight
		If (newHeight = 0 ) Then newHeight = oldHeight * newWidth / oldWidth
		image = image.Resize(newWidth, newHeight, False)
	End If
  
	'Convert image to JPEG byte array
	Dim out As OutputStream
		out.InitializeToBytesArray(0)
	image.WriteToStream(out, quality, "JPEG")
	out.Close
  
	'Done
	Return out.ToBytesArray
End Sub
#End Region
